using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Net;

namespace CSAPI
{
    public class CSApi
    {
        private static string UrlEncode(string str)
        {
            if (str == null) return "";

            Encoding enc = Encoding.ASCII;
            StringBuilder result = new StringBuilder();

            foreach (char symbol in str)
            {
                byte[] bs = enc.GetBytes(new char[] { symbol });
                for (int i = 0; i < bs.Length; i++)
                {
                    byte b = bs[i];
                    if (b >= 48 && b < 58 || b >= 65 && b < 65 + 26 || b >= 97 && b < 97 + 26) // decode non numalphabet
                    {
                        result.Append(Encoding.ASCII.GetString(bs, i, 1));
                    }
                    else
                    {
                        result.Append('%' + String.Format("{0:X2}", (int)b));
                    }
                }
            }

            return result.ToString();
        }

        private static string WebPost(string url, params string[] ps)
        {
            try
            {
                HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);
                request.Proxy = GlobalProxySelection.GetEmptyWebProxy();
                request.ServicePoint.ConnectionLimit = 1000;
                string str = "";
                for (int i = 0; i + 1 < ps.Length; i += 2)
                {
                    str += UrlEncode(ps[i]) + "=" + UrlEncode(ps[i + 1]) + "&";
                }
                if (str.EndsWith("&"))
                {
                    str = str.Substring(0, str.Length - 1);
                }
                request.Method = "POST";
                request.ContentType = "application/x-www-form-urlencoded";
                byte[] data = Encoding.ASCII.GetBytes(str);
                request.ContentLength = data.Length;
                Stream newStream = request.GetRequestStream();
                newStream.Write(data, 0, data.Length);

                WebResponse response = request.GetResponse();
                Stream sStream = response.GetResponseStream();
                StreamReader reader = new StreamReader(sStream);
                string retContent = reader.ReadToEnd();
                reader.Close();
                response.Close();
                newStream.Close();
                return retContent;
            }
            catch
            {
                return "";
            }
        }

        public static Dictionary<string, string> Split(string con)
        {
            Dictionary<string, string> ret = new Dictionary<string, string>();
            if (con == null) return ret;
            string[] lines = con.Split('\n');
            foreach (string line in lines)
            {
                string x = line.Trim();
                int sidx = x.IndexOf(' ');
                string name = "";
                string value = "";
                if (sidx >= 0)
                {
                    name = x.Substring(0, sidx);
                    value = x.Substring(sidx + 1).Trim();
                }
                else
                {
                    name = x;
                    value = "";
                }
                if (name != "") ret[name] = value;
            }
            return ret;
        }

        // return null if failed
        public static string Decode(string key, out string task_id, string image_fn)
        {
            task_id = "-1";

            // read image data
            byte[] data = File.ReadAllBytes(image_fn);

            // base64 encode it
            string im = Convert.ToBase64String(data);

            // submit captcha to server
            string con = WebPost("http://bypasscaptcha.com/upload.php", new string[] {
                "key", key,
                "file", im,
                "submit", "Submit",
                "gen_task_id", "1",
                "base64_code", "1"});
            Dictionary<string, string> dict = Split(con);
            if (dict.ContainsKey("TaskId")) task_id = dict["TaskId"];
            if (dict.ContainsKey("Value")) return dict["Value"];
            return null;
        }

        public static void Feedback(string key, string task_id, bool is_input_correct)
        {
            WebPost("http://bypasscaptcha.com/check_value.php", new string[] {
                "key", key,
                "task_id", task_id,
                "cv", (is_input_correct ? "1" : "0"),
                "submit", "Submit"});
        }

        public static int Left(string key)
        {
            string con = WebPost("http://bypasscaptcha.com/ex_left.php", new string[] { "key", key });
            Dictionary<string, string> dict = Split(con);
            if (!dict.ContainsKey("Left")) return -1;
            return int.Parse(dict["Left"]);
        }

        public static void Example()
        {
            // you need to change the key to your own
            string key = "85441743985f2df58af91e1b3af4709295a7ddae";
            string task_id = "-1";
            string captcha_fn = "captcha.jpg";

            Console.WriteLine("Decoding.");
            string value = Decode(key, out task_id, captcha_fn);
            Console.WriteLine("Decoded value is: {0}", value);
            Console.WriteLine("Suppose we check it as right.");
            Feedback(key, task_id, true);
            Console.WriteLine("OK.");

            Console.WriteLine("Left {0} credits on this key.", Left(key));
            Console.WriteLine("Press any key to exit.");
            Console.ReadKey();
        }
    }
}
